/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 1/29/2006; 2:38:38 PM

#include "All.h"


//Vectors.c
short getAngle(short,short);
short simplifyAngle(short);
//Explosion.c
void createExplosion(short, short);

char diskX[] = {0,1,2,3,3,3,2,1,0,  -1,-2,-3,-3,-3,-2,-1};
char diskY[] = {3,3,2,1,0, -1,-2,-3, -3,-3,-2,-1,0,1,2,3};
char diskX2[] = {1,3,4,4,3,1, -1,-3,-4,-4,-3,-1};
char diskY2[] = {4,3,1, -1,-3,-4,-4,-3,-1,1,3,4};


/*
        for (i=0;i<diskX.length;i++) {
            angle = Math.atan((-diskY[i]+7.5)/(diskX[i]-7.5));
            if (diskX[i]-7.5<0) angle+=Math.PI;
            while (angle<0) angle+=Math.PI*2;
            int v = (int)((128*angle)/(Math.PI*2));          
            System.out.print("," + v);
        }
*/



/*

*/
short fastCollision(unsigned char l[][128],short x, short y) {
	short i,j;
	short X = (x)/12;
	short Y = (y)/12;
	short n=0,a=a;
	x+=8;
	y+=8;
	x-=12*X;
	y-=12*Y;
	memset(allocatedMem->collisionBuffer,0,30*16*3);
	for  (i=0;i<3;i++) {//x
		for (j=0;j<3;j++) {//y
			a = l[Y+j][X+i];
			if (a < NUMBER_OF_TILES) {
				Sprite16_OR(12*i,12*j,12, &(allocatedMem->decompressedMasks->data[ a<<4 ]),allocatedMem->collisionBuffer);	
			}
		}
	}
	
	for (i=0;i<16;i++) {
		if (EXT_GETPIX(allocatedMem->collisionBuffer,x+diskX[i],y+diskY[i])) {
		 	n++;
		 	return 1;
		}
		//EXT_SETPIX(allocatedMem->collisionBuffer,x+diskX[i],y+diskY[i]);
	}
	//memcpy(allocatedMem->buffer,allocatedMem->collisionBuffer,30*12*4);
	return 0;
}



/*

*/
short largeCollision(unsigned char l[][128],short x, short y) {
	short i,j;
	short X = (x)/12;
	short Y = (y)/12;
	short n=0,a=a;
	x+=8;
	y+=8;
	x-=12*X;
	y-=12*Y;
	memset(allocatedMem->collisionBuffer,0,30*16*3);
	for  (i=0;i<3;i++) {//x
		for (j=0;j<3;j++) {//y
			a = l[Y+j][X+i];
			if (a < NUMBER_OF_TILES) {
				Sprite16_OR(12*i,12*j,12, &(allocatedMem->decompressedMasks->data[ a<<4 ]),allocatedMem->collisionBuffer);	
			}
		}
	}
	
	for (i=0;i<11;i++) {
		if (EXT_GETPIX(allocatedMem->collisionBuffer,x+diskX2[i],y+diskY2[i])) {
		 	n++;
		 	return 1;
		}
	}
	return 0;
}



/*

*/
char abcdef[] = {0,0,	0,1,	1,0,	0,-1,	-1,0,	1,1,	1,-1,	-1,1,	-1,-1,
									0,2,	2,0,	-2,0,	0,-2,
									1,2,	2,1,	-2,1,	1,-2,
									-1,2,	2,-1,	-2,-1,	-1,-2,
									2,2,	2,2,	-2,2,	2,-2,
									-2,2,	2,-2,	-2,-2,	-2,-2
	};
void handleCollisions(Player *p) {
	if (fastCollision(allocatedMem->map,p->x>>6,p->y>>6)) {
		p->x+=p->vx>>7;
		p->y+=p->vy>>7;
		
		p->vx = 0;
		p->vy = 0;
		p->shiftedSpeed = 0;
		p->speed = 0;
		long x = p->x>>6;
		long y = p->y>>6;
		long x2=x,y2=y;
		char *a=abcdef;
		while (largeCollision(allocatedMem->map,x2,y2)) {
			x2=x+(*a++);
			y2=y+(*a++);
		}
		
		p->x = x2<<6;
		p->y = y2<<6;
		
	}
}