/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 4/11/2006; 1:20:36 AM

#include "All.h"

//Display Map.c
void displayMap(unsigned char [][128], short, short, short, char *);
//Explosion.c
void drawAndUpdateExplosions(short, short, short, char *);
//Waypoints.c
void drawWaypoint(short, short, short, short, short, short, short, char *);
//Draw Ghost.c
void drawGhost(long, long, short, char *);

/*
	Calls all the functions drawing something on the screen
*/
void drawEverything(Player *p, char *buffer, unsigned char l[][128]) {
	displayMap(l,(p->x>>6)-(sinTable_128x12[p->angle]>>5),(p->y>>6)-(cosTable_128x12[p->angle]>>5),p->angle,buffer);
	//drawAndUpdateExplosions(p->x, p->y, p->angle, buffer);
	//drawWaypoint(p->x, p->y, p->angle,0,0,400,400,buffer);
	


	short x=TI89?4*16:16;
	short y=TI89?106:128-14;
	SpriteX8_MASK_R(x,y,14,cadran,cadranMask,3,buffer);
	x+=11;
	y+=12;
	short a = abs(p->speed)>>1;
	FastDrawLine(buffer,x,y,x-(cosTable_128x12[a]>>7),y-(sinTable_128x12[a]>>7),A_NORMAL);
	Sprite8_OR_R((240-8)/2,(128-8)/2 + 48,8,&carSprite[12*8],buffer);
	if (allocatedMem->playGhost)
	drawGhost(p->x, p->y, p->angle, buffer);
}

/*

*/
void copyBufferToScreen() {
	if (!TI89)
	memcpy(LCD_MEM,allocatedMem->buffer,LCD_SIZE);
	else
	memcpy(LCD_MEM,allocatedMem->buffer+5+20*30,30*100);
}